#!/usr/bin/env bash

ENVFIILE=/etc/prometheus/node_exporter/portage_exporter.env
[[ -f "$ENVFIILE" ]] && source "$ENVFIILE"

REPO_BASE=${REPO_BASE:-/home/backup/borg}
TEXTFILE_COLLECTOR_DIR=${TEXTFILE_COLLECTOR_DIR:-/var/lib/node_exporter/}

PROM_FILE=$TEXTFILE_COLLECTOR_DIR/portage.prom
TMP_FILE=$PROM_FILE.$$


echo "# TYPE portage_age_seconds gauge"
echo "# TYPE update_count gauge"
echo "# TYPE selected_update_count gauge"
echo "# TYPE glsa_count gauge"

HOSTNAME=${HOSTNAME:-$(hostname)}
(
  portage_timestamp="/usr/portage/metadata/timestamp"
  age_seconds="$(( $(date +%s) - $(date +%s -r "$portage_timestamp") ))"
  update_count="$(eix -u -c | wc -l)"
  selected_update_count="$(eix -u -c --selected | wc -l)"
  glsa_count=$[$(glsa-check -t all | wc -l )]
  echo portage_age_seconds\{host=\""$HOSTNAME"\"\} "$age_seconds"
  echo update_count\{host=\""$HOSTNAME"\"\} "$update_count"
  echo selectd_update_count\{host=\""$HOSTNAME"\"\} "$selected_update_count"
  echo glsa_count\{host=\""$HOSTNAME"\"\} "$glsa_count"
)> "$TMP_FILE"
mv "$TMP_FILE" "$PROM_FILE"
